<?php


/**
 * Class Session
 */
class Session
{

    /**
     * @var
     */
    protected $id;
    /**
     * @var
     */
    protected $name;
    /**
     * @var
     */
    protected $quantity;
    /**
     * @var
     */
    protected $merk;
    /**
     * @var
     */
    protected $price;

    /**
     * Session constructor.
     * @param $id
     * @param $name
     * @param $quantity
     * @param $merk
     * @param $price
     */
    public function __construct($id, $name, $quantity, $merk, $price)
    {
        $this->id = $id;
        $this->name = $name;
        $this->quantity = $quantity;
        $this->merk = $merk;
        $this->price = $price;
    }

    /**
     * Hier start een sessie op
     */
    public static function sessionStarter()
    {
        if (session_status() == PHP_SESSION_NONE) {
            session_start();
        }
    }

    /**
     * Hier beeindigt een sessie uit
     */
    public static function sessionEnder()
    {
        if (isset($_SESSION['session'])) {
            unset($_SESSION['session']);
        }
    }

    /**
     * Hier toevoeg gegevens aan Session in Array
     */
    public function addToSession()
    {
        if (!isset($_SESSION['session'])) {
            $_SESSION['session'] = array();
        }
        if (!empty($this->id && !empty($this->name) && !empty($this->quantity) && !empty($this->quantity) && !empty($this->merk) && !empty($this->price))) {
            $new_item = array(
                'p_id' => $this->id,
                'p_name' => $this->name,
                'p_qty' => $this->quantity,
                'p_merk' => $this->merk,
                'p_price' => $this->price,
            );
            $item_exist = self::checkIfItemExists($this->id, $_SESSION['session']);

            if ($item_exist !== false) {
                $_SESSION['session'][$item_exist]['p_qty'] = $this->quantity + $_SESSION['session'][$item_exist]['p_qty'];
            } else {
                $_SESSION['session'][] = $new_item;
            }
        }
    }

    /**
     * @param $id
     * @param $SESSION
     * @return bool|int|string
     *  Hier checkt of deze item bestaat in het session
     */
    protected static function checkIfItemExists($id, $SESSION)
    {
        if (is_array($SESSION)) {
            foreach ($SESSION as $key => $item) {
                if ($item['p_id'] === $id)
                    return $key;
            }
        }
        return false;
    }

    /**
     * Echo hier een tabel met Session-gegevens
     */
    public static function printSession()
    {
        $subtotaldata = null;
        if (!isset($_SESSION['session'])) {
            echo "Er is geen session die bestaat.";
        } else {
            echo "<div class='col-md-12'>";
            echo "<table class='table'>";
            echo "<thead class='thead-dark'>";
            echo "<tr>";
            echo "<th scope='col'>ID</th>";
            echo "<th scope='col'>Naam</th>";
            echo "<th scope='col'>Aantal</th>";
            echo "<th scope='col'>Merk</th>";
            echo "<th scope='col'>Prijs</th>";
            echo "<th scope='col'>Subtotaal</th>";
            echo "</tr>";
            echo "<tbody>";
            foreach ($_SESSION['session'] as $item) {
                $productmultiplier = $item['p_price'] * $item['p_qty'];
                $subtotaldata += $productmultiplier;
            }
            foreach ($_SESSION['session'] as $item) {
                $productmultiplier = $item['p_price'] * $item['p_qty'];
                echo "<tr>";
                echo "<td>" . $item['p_id'] . "</td>";
                echo "<td>" . $item['p_name'] . "</td>";
                echo "<td>" . $item['p_qty'] . "</td>";
                echo "<td>" . $item['p_merk'] . "</td>";
                echo "<td>&euro; " . $item['p_price'] . "</td>";
                echo "<td>&euro; " . number_format($productmultiplier, 2) . "</td>";
                echo "</tr>";
            }
            echo "</table>";
            echo "<h4>Totaal: &euro; " . number_format($subtotaldata, 2) . "</h4>";
        }
    }
}
// bron weergeven
if(isset($_POST['submit2'])){
    show_source(__FILE__);
}

?>
<form method="post">
    <input type="submit" name="submit2" value="Klik voor de broncode">
</form>

